
 Xa99 Cross Assembler
CONV ROUTINES 15/12/2001                                     PAGE 0001
  0001            *
  0002            * conversion routines 1.0
  0003            *
  0004            * Frederik G. Kaal 15/12/2001
  0005            *
  0007            
  0008                   IDT 'CONV'
  0009            
  0010                   DEF XTOL,XTOI,XCTOI,ATOL,ATOI
  0011            
  0012                   REF GETCP * see CTYPE
  0013            
  0014      0008  UPPER  EQU  >08  * see CTYPE
  0015      0020  DIGIT  EQU  >20
  0016      0040  XDIGI  EQU  >40
  0017            
  0018            * xtol(long,hexstr) int *long; char *hexstr;
  0019            *
  0020            * convert hexadecimal string to long
  0021            * conversion continious until end of string or not hex chara
  0022            * returns long
  0023            *
  0024 0000 06A0  XTOL   BL   @CXL
       0002 0052'
  0025 0004 C22E         MOV  @4(14),8
       0006 0004 
  0026 0008 C602         MOV  2,*8
  0027 000A CA03         MOV  3,@2(8)
       000C 0002 
  0028 000E 045D         B    *13
  0029            
  0030            * xtoi(hexstr) char *hexstr;
  0031            *
  0032            * convert hexadecimal string to int
  0033            * conversion continious until end of string or not xdigit
  0034            * returns int
  0035            *
  0036 0010 06A0  XTOI   BL   @CXL
       0012 0052'
  0037 0014 C203         MOV  3,8
  0038 0016 045D         B    *13
  0039            
  0040            * xctoi(hex) int hex;
  0041            *
  0042            * convert hexadecimal character to int
  0043            * returns int or -1 on error
  0044            *
  0045 0018 06A0  XCTOI  BL   @GETCP
       001A 0000 
  0046 001C 06A0         BL   @CXI
       001E 0028'
  0047 0020 1601         JNE  XCTOIX      Not xdigit
  0048 0022 045D         B    *13
  0049 0024 0708  XCTOIX SETO 8           Error
  0050 0026 045D         B    *13
  0051            
  0052            * cxi(hex) int hex
  0053            *
  0054            * convert hexadecimal character to int

 Xa99 Cross Assembler
CONV ROUTINES 15/12/2001                                     PAGE 0002
  0055            * returns if eq int R8
  0056            *         if ne error
  0057            *
  0058 0028 0200  CXI    LI   0,XDIGI*256 Xdigit?
       002A 4000 
  0059 002C 2040         COC  0,1
  0060 002E 1610         JNE  CXI#X       No!
  0061 0030 0241         ANDI 1,XDIGI+DIGIT+UPPER*256
       0032 6800 
  0062 0034 0281         CI   1,XDIGI+DIGIT*256
       0036 6000 
  0063 0038 1308         JEQ  CXI#3       Digit!
  0064 003A 0281         CI   1,XDIGI+UPPER*256
       003C 4800 
  0065 003E 1302         JEQ  CXI#2       Uppercase A-F
  0066 0040 0228         AI   8,'A'-'a'   toupper a-f
       0042 FFE0 
  0067 0044 0228  CXI#2  AI   8,10-'A'
       0046 FFC9 
  0068 0048 1002         JMP  CXI#4
  0069 004A 0228  CXI#3  AI   8,0-'0'
       004C FFD0 
  0070 004E 22CB  CXI#4  COC  11,11       Eq
  0071 0050 045B  CXI#X  B    *11
  0072            
  0073            * cxl(hexstr) char *hexstr
  0074            *
  0075            * convert hexadecimal string to long
  0076            * conversion continious until end of string or not xdigit
  0077            * returns long in R2 and R3
  0078            *
  0079 0052 C24B  CXL    MOV  11,9
  0080 0054 C1C8         MOV  8,7         R7=*hexstr
  0081 0056 04C2         CLR  2           Long result
  0082 0058 04C3         CLR  3
  0083 005A D237  CXL#1  MOVB *7+,8       Get char
  0084 005C 130D         JEQ  CXL#X
  0085 005E 0988         SRL  8,8
  0086 0060 06A0         BL   @GETCP
       0062 001A'
  0087 0064 06A0         BL   @CXI
       0066 0028'
  0088 0068 1607         JNE  CXL#X       No!
  0089            
  0090 006A C103  CXL#4  MOV  3,4
  0091 006C 0A42         SLA  2,4
  0092 006E 0A43         SLA  3,4
  0093 0070 09C4         SRL  4,12
  0094 0072 A084         A    4,2
  0095 0074 A0C8         A    8,3
  0096 0076 10F1         JMP  CXL#1
  0097 0078 0459  CXL#X  B    *9
  0098            
  0099            * atol(long,decstr) int *long; char *decstr;
  0100            *
  0101            * convert decimal string to long
  0102            * conversion continious until end of string or not digit
  0103            * returns long
  0104            *

 Xa99 Cross Assembler
CONV ROUTINES 15/12/2001                                     PAGE 0003
  0105 007A 06A0  ATOL   BL   @CDL
       007C 0094'
  0106 007E C22E         MOV  @4(14),8
       0080 0004 
  0107 0082 C602         MOV  2,*8
  0108 0084 CA04         MOV  4,@2(8)
       0086 0002 
  0109 0088 045D         B    *13
  0110            
  0111            * atoi(decstr) char *decstr;
  0112            *
  0113            * convert decimal string to long
  0114            * conversion continious until end of string or not digit
  0115            * returns int
  0116            *
  0117 008A 06A0  ATOI   BL   @CDL
       008C 0094'
  0118 008E C204         MOV  4,8
  0119 0090 045D         B    *13
  0120            
  0121            * cdl(decstr) char *decstr
  0122            *
  0123            * convert decimal string to long
  0124            * conversion continious until end of string or not xdigit
  0125            * returns long in R2 and R4, sign in R0
  0126            *
  0127 0092   2D  SIGN#N BYTE '-'
  0128 0093   2B  SIGN#P BYTE '+'
  0129            
  0130 0094 C24B  CDL    MOV  11,9
  0131 0096 C1C8         MOV  8,7         R7=*hexstr
  0132 0098 04C0         CLR  0           Sign
  0133 009A 04C2         CLR  2           Long result HOW
  0134 009C 04C4         CLR  4           Long result LOW
  0135 009E 0206         LI   6,10        Multiplicand
       00A0 000A 
  0136 00A2 9817         CB   *7,@SIGN#N
       00A4 0092'
  0137 00A6 1304         JEQ  CDL#1
  0138 00A8 9817         CB   *7,@SIGN#P
       00AA 0093'
  0139 00AC 1302         JEQ  CDL#2
  0140 00AE 1002         JMP  CDL#3
  0141 00B0 0700  CDL#1  SETO 0           Negative
  0142 00B2 0587  CDL#2  INC  7
  0143 00B4 D237  CDL#3  MOVB *7+,8       Get char
  0144 00B6 130F         JEQ  CDL#X
  0145 00B8 0988         SRL  8,8
  0146 00BA 06A0         BL   @GETCP      Get char parameters
       00BC 0062'
  0147 00BE 0241         ANDI 1,DIGIT*256 Digit?
       00C0 2000 
  0148 00C2 1309         JEQ  CDL#X
  0149 00C4 0228         AI   8,0-'0'
       00C6 FFD0 
  0150            
  0151 00C8 3906         MPY  6,4      LOW(long)*10
  0152 00CA 3886         MPY  6,2      HOW(long)*10
  0153 00CC C083         MOV  3,2

 Xa99 Cross Assembler
CONV ROUTINES 15/12/2001                                     PAGE 0004
  0154 00CE A084         A    4,2
  0155 00D0 C105         MOV  5,4
  0156 00D2 A108         A    8,4
  0157 00D4 10EF         JMP  CDL#3
  0158            
  0159 00D6 0740  CDL#X  ABS  0
  0160 00D8 1304         JEQ  CDL#XX
  0161 00DA 0542         INV  2
  0162 00DC 0504         NEG  4
  0163 00DE 1601         JNE  CDL#XX
  0164 00E0 0582         INC  2
  0165 00E2 0459  CDL#XX B    *9
  0166            
  0167                   END

 Xa99 Cross Assembler
CONV ROUTINES 15/12/2001                                     PAGE 0005
  D ATOI    008A    D ATOL    007A    ' CDL     0094    ' CDL#1   00B0  
  ' CDL#2   00B2    ' CDL#3   00B4    ' CDL#X   00D6    ' CDL#XX  00E2  
  ' CXI     0028    ' CXI#2   0044    ' CXI#3   004A    ' CXI#4   004E  
  ' CXI#X   0050    ' CXL     0052    ' CXL#1   005A    ' CXL#4   006A  
  ' CXL#X   0078      DIGIT   0020    E GETCP   00BC      R0      0000  
    R1      0001      R10     000A      R11     000B      R12     000C  
    R13     000D      R14     000E      R15     000F      R2      0002  
    R3      0003      R4      0004      R5      0005      R6      0006  
    R7      0007      R8      0008      R9      0009    ' SIGN#N  0092  
  ' SIGN#P  0093      UPPER   0008    D XCTOI   0018    ' XCTOIX  0024  
    XDIGI   0040    D XTOI    0010    D XTOL    0000  
  0000 ERRORS

 Xa99 Cross Assembler
CONV ROUTINES 15/12/2001                                     PAGE 0006
  SEGMENT RORG     SIZE 00228 (>00E4) BYTES
