
 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0001
  0001            * MEMORY FUNCTIONS
  0002            
  0003                   DEF MEMSET,MEMMOV,MEMCPY,MEMCMP
  0004                   DEF XMSET,XMMOV,XMCPY,XMCMP
  0005            
  0006            * memset - set n bytes of memory with character c returns d
  0007            *
  0008            * memset(d,c,n) char *d,c; int n;
  0009            *
  0010            *   while(n--) *d++ = c;
  0011            *
  0012 0000 06A0  MEMSET BL   @GET012      0=d 1=c 2=n
       0002 010A'
  0013 0004 C200  XMSET  MOV  0,8
  0014 0006 C082         MOV  2,2
  0015 0008 1304         JEQ  MEMS#X       n=0
  0016 000A 06C1         SWPB 1
  0017 000C DC01  MEMS#1 MOVB 1,*0+        *d+=c
  0018 000E 0602         DEC  2            n--
  0019 0010 16FD         JNE  MEMS#1       while
  0020 0012 045D  MEMS#X B    *13
  0021            
  0022            * memmove - copy n bytes in memory from s to d returns d
  0023            *           will also work if d and s overlap
  0024            *
  0025            * memmove(d,s,n) char *d,*s; int n;
  0026            *
  0027            *   if ((s <d) && (s + n >= d)) {
  0028            *     d = d+n; s=s+n;
  0029            *     while(n--) *--d = *--s;
  0030            *   } else {
  0031            *     while(n--) *d++ = *s++;
  0032            *   }
  0033            *
  0034 0014 06A0  MEMMOV BL   @GET012      0=d 1=s 2=n
       0016 010A'
  0035 0018 C200  XMMOV  MOV  0,8
  0036 001A C082         MOV  2,2
  0037 001C 130D         JEQ  MEMM#X       n=0
  0038 001E 8001         C    1,0          s<d
  0039 0020 1411         JHE  MEMC#1       no
  0040 0022 C0C1         MOV  1,3
  0041 0024 A0C2         A    2,3          s+n>d
  0042 0026 8003         C    3,0
  0043 0028 1A0D         JL   MEMC#1       no
  0044 002A A002         A    2,0          d+n
  0045 002C A042         A    2,1          s+n
  0046 002E 0600  MEMM#1 DEC  0            --d
  0047 0030 0601         DEC  1            --s
  0048 0032 D411         MOVB *1,*0        *d=*s
  0049 0034 0602         DEC  2            n--
  0050 0036 16FB         JNE  MEMM#1       while
  0051 0038 045D  MEMM#X B    *13
  0052            
  0053            * memcpy - copy n bytes in memory from s to d returns d
  0054            *          unpredictable results f s and d overlap
  0055            *
  0056            * memcpy(d,s,n) char *d,*s; int n;
  0057            *

 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0002
  0058            *     while(n--) *d++ = *s++;
  0059            *
  0060 003A 06A0  MEMCPY BL   @GET012      0=d 1=s 2=n
       003C 010A'
  0061 003E C200  XMCPY  MOV  0,8
  0062 0040 C082         MOV  2,2
  0063 0042 1303         JEQ  MEMC#X       n=0
  0064 0044 DC31  MEMC#1 MOVB *1+,*0+      *d+=*s+
  0065 0046 0602         DEC  2            n--
  0066 0048 16FD         JNE  MEMC#1       while
  0067 004A 045D  MEMC#X B    *13
  0068            
  0069            * memcmp - compare n bytes of s and s
  0070            *
  0071            * memcmp(s1,s2,n) char *s1, *s2; int n;
  0072            *
  0073            * int r;
  0074            *   while (n--) {
  0075            *       r = *s1++ - *s2++;
  0076            *       if (r) return r;
  0077            *   } return 0;
  0078            *
  0079 004C 06A0  MEMCMP BL   @GET012      0=d 1=s 2=n
       004E 010A'
  0080 0050 C082  XMCMP  MOV  2,2
  0081 0052 130A         JEQ  MCMP#E       n=0
  0082 0054 04C8  MCMP#1 CLR  8
  0083 0056 D230         MOVB *0+,8
  0084 0058 06C8         SWPB 8            r=*s1++
  0085 005A 04C3         CLR  3
  0086 005C D0F1         MOVB *1+,3
  0087 005E 06C3         SWPB 3
  0088 0060 6203         S    3,8          r-=*s2++
  0089 0062 1603         JNE  MCMP#X       if(r) return r
  0090 0064 0602         DEC  2            n--
  0091 0066 16F6         JNE  MCMP#1
  0092 0068 04C8  MCMP#E CLR  8
  0093 006A 045D  MCMP#X B    *13
  0094            
  0095            * STRING FUNCTIONS
  0096            
  0097                   DEF STRCPY,STRNCP,STRLEN,STRCAT
  0098                   DEF STRCMP,STRNCM,STRCHR
  0099                   DEF XSCPY,XSNCPY,XSLEN,XSCAT
  0100                   DEF XSCMP,XSNCMP,XSCHR
  0101            
  0102            * strlen - return string length
  0103            *
  0104            * strlen(s) char *s;
  0105            *
  0106            * int n=0;
  0107            * while(*s++) n++;
  0108            * return n;
  0109            *
  0110 006C C02E  STRLEN MOV  @2(14),0     s
       006E 0002 
  0111 0070 04C8  XSLEN  CLR  8            n=0
  0112 0072 D0F0  STRL#1 MOVB *0+,3        *s++
  0113 0074 1302         JEQ  STRL#X       while

 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0003
  0114 0076 0588         INC  8            n++
  0115 0078 10FC         JMP  STRL#1
  0116 007A 045D  STRL#X B    *13
  0117            
  0118            * strchr - returns pointer of first occurence of c in s NULL
  0119            *
  0120            * strchr(s,c) char *s,c;
  0121            *
  0122            * while(*s) if (*s!=c) s++ else return s;
  0123            *
  0124 007C 06A0  STRCHR BL   @GET12       1=s 2=c
       007E 010E'
  0125 0080 04C8  XSCHR  CLR  8
  0126 0082 06C2         SWPB 2
  0127 0084 D0F1  SCHR#1 MOVB *1+,3        *s++
  0128 0086 1304         JEQ  SCHR#X       while
  0129 0088 9083         CB   3,2          *s!=c
  0130 008A 16FC         JNE  SCHR#1
  0131 008C C201         MOV  1,8
  0132 008E 0608         DEC  8
  0133 0090 045D  SCHR#X B    *13
  0134            
  0135            * strcpy - copy string s into d returns d
  0136            *
  0137            * strcpy(d, s) char *d,*s;
  0138            *
  0139            *   while ((*d++) = (*s++));
  0140            *
  0141 0092 06A0  STRCPY BL   @GET12       1=d  2=s
       0094 010E'
  0142 0096 C201  XSCPY  MOV  1,8
  0143 0098 DC72  STRC#1 MOVB *2+,*1+      *d++=*s++
  0144 009A 16FE         JNE  STRC#1       while
  0145 009C 045D         B    *13
  0146            
  0147            * strncpy - copy atmost n characters from string s into d re
  0148            *
  0149            * strncpy(d, s, n) char *d,*s; int n;
  0150            *
  0151            *   while (n-- && ((*d++) = (*s++)));
  0152            *
  0153 009E 06A0  STRNCP BL   @GET012      0=d, 1=s, 2=n
       00A0 010A'
  0154 00A2 C200  XSNCPY MOV  0,8
  0155 00A4 C082         MOV  2,2
  0156 00A6 1304         JEQ  SNCY#2       n=0
  0157 00A8 DC31  SNCY#1 MOVB *1+,*0+      *d++=*s++
  0158 00AA 1303         JEQ  SNCY#3       while
  0159 00AC 0602         DEC  2            n--
  0160 00AE 16FC         JNE  SNCY#1
  0161 00B0 D402  SNCY#2 MOVB 2,*0         end with '\0'
  0162 00B2 045D  SNCY#3 B    *13
  0163            
  0164            * strcat - concatenate s to the end of d returns d
  0165            *
  0166            * strcat(d, s) char *d, *s;
  0167            *
  0168            *   while (*d++);
  0169            *   d--;

 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0004
  0170            *   strcpy(d,s);
  0171            *
  0172 00B4 C02E  STRCAT MOV  @4(14),0     d
       00B6 0004 
  0173 00B8 C06E         MOV  @2(14),1     s
       00BA 0002 
  0174 00BC C200  XSCAT  MOV  0,8
  0175 00BE D0F0  STRC#2 MOVB *0+,3        *d++
  0176 00C0 16FE         JNE  STRC#2       while
  0177 00C2 0600         DEC  0            d--
  0178 00C4 DC31  STRC#3 MOVB *1+,*0+      *d++=*s++
  0179 00C6 16FE         JNE  STRC#3       while
  0180 00C8 045D         B    *13
  0181            
  0182            * chrcmp - compare two characters
  0183            *
  0184            * R0 = char s1
  0185            * R1 = char s2
  0186            *
  0187 00CA D0D0  CHRCMP MOVB *0,3         *s1
  0188 00CC F0D1         SOCB *1,3         ||*s2
  0189 00CE 1310         JEQ  SCMP#E       while
  0190 00D0 04C8         CLR  8
  0191 00D2 D230         MOVB *0+,8
  0192 00D4 06C8         SWPB 8            r=*s1++
  0193 00D6 04C3         CLR  3
  0194 00D8 D0F1         MOVB *1+,3
  0195 00DA 06C3         SWPB 3
  0196 00DC 6203         S    3,8          r-=*s2++
  0197 00DE 045B         B    *11
  0198            
  0199            * strcmp - compare s1 and s2
  0200            * returns > 0 if s1 > s2
  0201            * returns   0 if s1 = s2
  0202            * returns < 0 if s1 < s2
  0203            *
  0204            * strcmp(s1,s2) char *s1, *s2;
  0205            *
  0206            * int r;
  0207            *
  0208            *   while (*s1 || *s2) {
  0209            *       r = *s1++ - *s2++;
  0210            *       if (r) return r;
  0211            *   } return 0;
  0212            *
  0213 00E0 C02E  STRCMP MOV  @4(14),0     0=s1
       00E2 0004 
  0214 00E4 C06E         MOV  @2(14),1     1=s2
       00E6 0002 
  0215 00E8 06A0  XSCMP  BL   @CHRCMP
       00EA 00CA'
  0216 00EC 1602         JNE  SCMP#X       if(r) return r
  0217 00EE 10FC         JMP  XSCMP
  0218 00F0 04C8  SCMP#E CLR  8
  0219 00F2 045D  SCMP#X B    *13
  0220            
  0221            * strncmp - compare n chars of s1 and s2
  0222            *
  0223            * strncmp(s1,s2,n) char *s1, *s2; int n;

 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0005
  0224            *
  0225            * int r;
  0226            *   while ((*s1 || *s2) && n--) {
  0227            *       r12 = *s1++ - *s2++;
  0228            *       if (r12) return r12;
  0229            *   } return 0;
  0230            *
  0231 00F4 06A0  STRNCM BL   @GET012      0=s1 1=s2 2=n
       00F6 010A'
  0232 00F8 C082  XSNCMP MOV  2,2
  0233 00FA 1305  SNCP#1 JEQ  SNCP#E       n=0
  0234 00FC 06A0         BL   @CHRCMP
       00FE 00CA'
  0235 0100 1603         JNE  SNCP#X       if(r) return r
  0236 0102 0602         DEC  2            n--
  0237 0104 10FA         JMP  SNCP#1
  0238 0106 04C8  SNCP#E CLR  8
  0239 0108 045D  SNCP#X B    *13
  0240            
  0241            * GET012 - Get R0=First, R1=Second, R2=Third argument
  0242            * GET12  - Get R1=First R2=Second argument
  0243            *
  0244 010A C02E  GET012 MOV  @6(14),0     First
       010C 0006 
  0245 010E C06E  GET12  MOV  @4(14),1     Second
       0110 0004 
  0246 0112 C0AE         MOV  @2(14),2     Third
       0114 0002 
  0247 0116 045B         B    *11
  0248                   END

 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0006
  ' CHRCMP  00CA    ' GET012  010A    ' GET12   010E    ' MCMP#1  0054  
  ' MCMP#E  0068    ' MCMP#X  006A    ' MEMC#1  0044    ' MEMC#X  004A  
  D MEMCMP  004C    D MEMCPY  003A    ' MEMM#1  002E    ' MEMM#X  0038  
  D MEMMOV  0014    ' MEMS#1  000C    ' MEMS#X  0012    D MEMSET  0000  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
  ' SCHR#1  0084    ' SCHR#X  0090    ' SCMP#E  00F0    ' SCMP#X  00F2  
  ' SNCP#1  00FA    ' SNCP#E  0106    ' SNCP#X  0108    ' SNCY#1  00A8  
  ' SNCY#2  00B0    ' SNCY#3  00B2    ' STRC#1  0098    ' STRC#2  00BE  
  ' STRC#3  00C4    D STRCAT  00B4    D STRCHR  007C    D STRCMP  00E0  
  D STRCPY  0092    ' STRL#1  0072    ' STRL#X  007A    D STRLEN  006C  
  D STRNCM  00F4    D STRNCP  009E    D XMCMP   0050    D XMCPY   003E  
  D XMMOV   0018    D XMSET   0004    D XSCAT   00BC    D XSCHR   0080  
  D XSCMP   00E8    D XSCPY   0096    D XSLEN   0070    D XSNCMP  00F8  
  D XSNCPY  00A2  
  0000 ERRORS

 Xa99 Cross Assembler
VERSION 1.2/C                                                PAGE 0007
  SEGMENT RORG     SIZE 00280 (>0118) BYTES
