@ECHO OFF
REM L99.BAT
REM
REM Batch file for linking a TI99/4A programs
REM
REM This batchfile is intended to be used with TotalCommander
REM  Command=		?:\Ti994w\Utl\L99.bat
REM  Parameters=	%O %E or %N
REM  Iconfile=		?:\Ti994w\Utl\L99.exe
REM  Tooltip=		L99 - Linker for the TI99/4A
REM
REM
REM Author : Frederik G. Kaal
REM Version: 2.0
REM Date   : 02-01-2021
REM 
REM Call: L99.BAT input_file_name (with extension)


@echo [%1] [%2] [%3] [%4] [%5]

SET SPACE=
SET PATH=D:\TI994W\UTL;%PATH%
SET VIEWER=d:\promite\utl\com\uedit\Uedit32.exe

IF [%2]==[] goto V20
:V10
SET NAME=%1
SET EXT=.%2
GOTO :VXX

:V20
SET NAME=%~n1
SET EXT=%~x1
:VXX

REM ECHO [%NAME%]
REM ECHO [%EXT%]
REM PAUSE

if [%EXT%]==[.L99] goto link
if [%EXT%]==[.l99] goto link

COLOR CE
ECHO *** ERROR ***
start /WAIT wmessage -M%NAME%%EXT% does not have the right extension like .L99 -TL99 -K1 -I4
goto end

:link
@echo Start Linking
if exist %NAME%.ler del %NAME%.ler
@echo L99.EXE %NAME%%EXT%
@echo L99.EXE %NAME%%EXT% >%NAME%.ler
L99.EXE -L%NAME%%EXT% -E%NAME%.ler -M%NAME%.map
if errorlevel 1 goto linkerr
goto end

:linkerr
start /WAIT wmessage -MLinker errors -TL99 -K1 -I4
%VIEWER% %NAME%.ler
set ERROR=1
goto end

:end
